/*
 * =============================================================================
 *
 *       Filename:  Definitions.h
 *    Description:  stores definitions in one place
 *        Created:  10/30/2011 21:28:31
 *
 *         Author:  Derek Tingle (dt), derek.tingle@gmail.com
 *
 * =============================================================================
 */

#ifndef __DEFINITIONS_H__
#define __DEFINITIONS_H__

#include <GLUT/glut.h>
#include "MyColors.h"

#define NUM_CHANS 2
#define MY_SRATE 44100
#define SAMPLE float
#define RT_BUFF_SIZE 2048
#define ZPF 2
#define PI 3.14159265358979

#define DB_PATH "/Users/slork/code/ccrma/256a/project/data/all.db"
#define WAV_DIR "/Users/slork/code/ccrma/256a/project/data/wav/"

// to test blob
#define USE_BLOBS   0
#define MAX_DOTS 500
#define NUM_DOTS 50000
#define LIT_DOTS 50
#define DIM_ALPHA .3
#define DIM_R 0.001
#define BRIGHT_R 0.005

#define DEBUG 1
//RtAudio format
//#define RT_FORMAT RTAUDIO_FLOAT64


struct pt3d
{
  pt3d( GLdouble x, GLdouble y, GLdouble z ) : x(x), y(y), z(z) {};
  pt3d() : x(-1000000.0), y(-1000000.0),z(-1000000.0) {};
  
  double x;
  double y;
  double z;
};

struct pt4d
{
  pt4d( GLdouble x, GLdouble y, GLdouble z,GLdouble a) : x(x), y(y), z(z), a(a) {};
  pt4d() : x(0), y(0),z(0),a(0) {};
  
  double x,y,z,a;
};

struct lit_dot
{
  lit_dot(): pos(),color(){};
  lit_dot(pt4d pos,RGB_color color): pos(pos), color(color){};

  pt4d pos;
  RGB_color color;
};

#endif

