/*
 * =============================================================================
 *
 *       Filename:  MyColors.h
 *    Description:  RGB and HSV classes
 *
 *                  shamelessy taken and tweaked from:
 *                  http://www.alvyray.com/Papers/CG/hsv2rgb.htm
 *
 *        Created:  10/31/2011 00:06:39
 *
 *         Author:  Derek Tingle (dt), derek.tingle@gmail.com
 *
 * =============================================================================
 */

#ifndef __MY_COLORS__
#define __MY_COLORS__

class RGB_color{
  public:
    RGB_color(float r=0, float g=0, float b=0);

    float r;
    float g;
    float b;
};

class HSV_color{
  public:
    HSV_color(float h=0, float s=0, float v=0);

    float h;
    float s;
    float v;
};

// converts an HSV to RGB
RGB_color hsv_to_rgb( HSV_color HSV);
#endif
