/*
 * =============================================================================
 *
 *       Filename:  Song.h
 *    Description:  Class to store a libsndfile SF_INFO and SNDFILE, as well
 *                  as an array of dots to draw
 *
 *        Created:  12/05/2011 04:44:50
 *
 *         Author:  Derek Tingle (dt), derek.tingle@gmail.com
 *
 * =============================================================================
 */

#ifndef __DT_SONG_H__
#define __DT_SONG_H__

#include <iostream>
#include <string>
#include <sndfile.h>
#include <vector>
#include <exception>
#include <cmath>

#include <GLUT/glut.h>

#include <soci/soci.h>
#include <soci/soci-backend.h>
#include <soci/sqlite3/soci-sqlite3.h>

#include "Definitions.h"
#include "MyColors.h"

class Song {

public:
  Song();
  ~Song();
  void open(const char *name);
  void set_color(RGB_color c);
  void init(int db_id);
  void draw_dots();
    
public:
  SF_INFO *info;
  SNDFILE *file;
  RGB_color color;

  int db_id,num_points;
  std::vector<double> *x,*y,*z;
  double max1,min1,max2,min2,max3,min3;

};

#endif
