DROP TABLE IF EXISTS tracks;
CREATE TABLE tracks (
  id INTEGER    PRIMARY KEY,
  name VARCHAR  NOT NULL
  );

DROP TABLE IF EXISTS feats;
CREATE TABLE feats (
  id  INTEGER   PRIMARY KEY,
  track_id INTEGER NOT NULL,
  frame_start INTEGER NOT NULL,
  zcr FLOAT     NOT NULL,
  FOREIGN KEY(track_id) REFERENCES track(id)
  );

DROP TABLE IF EXISTS mfccs;
CREATE TABLE mfccs (
  id  INTEGER   PRIMARY KEY,
  track_id INTEGER NOT NULL,
  frame_start INTEGER NOT NULL,
  mfcc1 FLOAT     NOT NULL,
  mfcc2 FLOAT     NOT NULL,
  mfcc3 FLOAT     NOT NULL,
  mfcc4 FLOAT     NOT NULL,
  mfcc5 FLOAT     NOT NULL,
  mfcc6 FLOAT     NOT NULL,
  mfcc7 FLOAT     NOT NULL,
  mfcc8 FLOAT     NOT NULL,
  mfcc9 FLOAT     NOT NULL,
  mfcc10 FLOAT     NOT NULL,
  FOREIGN KEY(track_id) REFERENCES track(id)
  );


DROP TABLE IF EXISTS r_feats;
DROP TABLE IF EXISTS r_feats_node;
DROP TABLE IF EXISTS r_feats_parent;
DROP TABLE IF EXISTS r_feats_rowid;
CREATE VIRTUAL TABLE r_feats using rtree (
  id,
  min_zcr,
  max_zcr
);

DROP TABLE IF EXISTS r_feats_data;
CREATE TABLE r_feats_data(
  id    INTEGER   PRIMARY KEY,
  track_id  INTEGER NOT NULL,
  frame_start INTEGER NOT NULL,
  zcr   FLOAT     NOT NULL,
  FOREIGN KEY(track_id) REFERENCES track(id)
);

DROP TABLE IF EXISTS r_mfccs_data;
CREATE TABLE r_mfccs_data(
  id    INTEGER   PRIMARY KEY,
  track_id  INTEGER NOT NULL,
  frame_start INTEGER,
  buff_size INTEGER,
  FOREIGN KEY(track_id) REFERENCES track(id)
);

DROP TABLE IF EXISTS r_mfccs;
DROP TABLE IF EXISTS r_mfccs_node;
DROP TABLE IF EXISTS r_mfccs_parent;
DROP TABLE IF EXISTS r_mfccs_rowid;
CREATE VIRTUAL TABLE r_mfccs using rtree (
  id,
  min_mfcc1,max_mfcc1,
  min_mfcc2,max_mfcc2,
  min_mfcc3,max_mfcc3,
  min_mfcc4,max_mfcc4,
  min_mfcc5,max_mfcc5
);
