/* =============================================================================
 *       Filename:  Extractor.h
 *    Description:  Class to hold the feature extraction data structures
 *        Created:  11/26/11 00:43:19
 *
 *         Author:  Derek Tingle, derek.tingle@gmail.com
 * ===========================================================================*/

#ifndef __EXTRACTOR_H__
#define __EXTRACTOR_H__

#include <xtract/libxtract.h>
#include "../Definitions.h"


class Extractor{
  // public functions
  public:
    Extractor(int c_buff_size=RT_BUFF_SIZE);
    ~Extractor();

    // get an array of mfccs 
    void get_mfccs(int sr);
    // check to see if the buffer is complete silence
    int detect_silence();
    // memset the buffer
    void clear_buff();

  // public variables
  public:
    int buff_size;
    SAMPLE * buff;
    double * mfccs;

  // protected functions
  protected:
    // window the buffer
    void apply_window();
    // bounce the buffer down to one channel
    void monofy();

  // protected variables
  protected:
    xtract_mel_filter * m_mel_filter;
    SAMPLE * m_mfcc_buff;
    float * m_spect, *m_tmp_mfccs;
    float m_spect_params[3];
};

#endif
